"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_redux_1 = require("react-redux");
var react_router_redux_1 = require("react-router-redux");
var redux_1 = require("redux");
var isModifiedEvent = function (event) {
    return !!(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
};
var Link = (function (_super) {
    __extends(Link, _super);
    function Link() {
        var _this = _super.call(this) || this;
        _this.handleClick = _this.handleClick.bind(_this);
        return _this;
    }
    Link.prototype.handleClick = function (e) {
        var _a = this.props, onClick = _a.onClick, target = _a.target;
        if (onClick) {
            onClick(e);
        }
        if (!e.defaultPrevented &&
            e.button === 0 &&
            !target &&
            !isModifiedEvent(e) // ignore clicks with modifier keys
        ) {
            e.preventDefault();
            var _b = this.props, pushUrl = _b.pushUrl, replace = _b.replace, replaceUrl = _b.replaceUrl, to = _b.to;
            if (replace) {
                replaceUrl(to);
            }
            else {
                pushUrl(to);
            }
        }
    };
    Link.prototype.render = function () {
        return React.createElement("a", { href: this.props.to, onClick: this.handleClick }, this.props.children);
    };
    return Link;
}(React.Component));
Link.defaultProps = {
    replace: false,
};
var mapDispatchToProps = function (dispatch) { return redux_1.bindActionCreators({
    pushUrl: react_router_redux_1.push,
    replaceUrl: react_router_redux_1.replace,
}, dispatch); };
exports.default = react_redux_1.connect(undefined, mapDispatchToProps)(Link);
//# sourceMappingURL=Link.js.map